Uint8 A71D39_Cal(void)
{
    Uint8 i;
    Uint8 fcd, fbcf;//IF Filter
    Uint8 vb,vbcf;          //VCO Current
    Uint8 vcb, vccf;        //VCO Band
    Uint16 tmp;
    bit fb_fail;	
    
    StrobeCMD(CMD_STBY);

    //IF calibration procedure @STB state
	if(fb_ok == 1)
	{
		A7139_WriteReg(MODE_REG, A7139Config[MODE_REG] | 0x0800);       //VCO Current Calibration
	    do{
	      tmp = A7139_ReadReg(MODE_REG);
	    }while(tmp & 0x0800);
		tmp = (A7139Config[CALIBRATION_REG] & 0xFFE0);
		tmp = tmp | fb | (1<<4);
		A7139_WriteReg(CALIBRATION_REG, tmp);
	}	
	else
	{	
	 fb_fail=0;
	
	 for(i=0;i<3;i++)
	 {
      A7139_WriteReg(MODE_REG, A7139Config[MODE_REG] | 0x0802);       //IF Filter & VCO Current Calibration
      do{
         tmp = A7139_ReadReg(MODE_REG);
      }while(tmp & 0x0802);
    
      //for check(IF Filter)
      tmp = A7139_ReadReg(CALIBRATION_REG);
      fb = tmp & 0x0F;
      fcd = (tmp>>11) & 0x1F;
      fbcf = (tmp>>4) & 0x01;
    
	  if((fb<4) || (fb>13))
		fb_fail = 1;

	  if((fbcf) || (fb_fail))
      {
        return 1;
      }
	 }
	}

    //for check(VCO Current)
    tmp = A7139_ReadPageA(VCB_PAGEA);
    vcb = tmp & 0x0F;
    vccf = (tmp>>4) & 0x01;
    if(vccf)
    {
         return 1;
    }
    
    
    //RSSI Calibration procedure @STB state
    A7139_WriteReg(ADC_REG, 0x4C00);                                    //set ADC average=64
    A7139_WriteReg(MODE_REG, A7139Config[MODE_REG] | 0x1000);           //RSSI Calibration
    do{
        tmp = A7139_ReadReg(MODE_REG);
    }while(tmp & 0x1000);
    A7139_WriteReg(ADC_REG, A7139Config[ADC_REG]);


    //VCO calibration procedure @STB state
    A7139_WriteReg(PLL1_REG, A7139Config[PLL1_REG]);
    A7139_WriteReg(PLL2_REG, A7139Config[PLL2_REG]);
    A7139_WriteReg(MODE_REG, A7139Config[MODE_REG] | 0x0004);       //VCO Band Calibration
    do{
        tmp = A7139_ReadReg(MODE_REG);
    }while(tmp & 0x0004);
    
    //for check(VCO Band)
    tmp = A7139_ReadReg(CALIBRATION_REG);
    vb = (tmp >>5) & 0x07;
    vbcf = (tmp >>8) & 0x01;
    if(vbcf)
    {
         return 1;
    }
 
	fb_ok = 1; 
    return 0;   
}
